{-----------------------------------------------------------------------}
{ RUNNING, ANALOG For DataTablePreparation, ver.1.0.                    }
{ (c) Logana Artificial Association Team (1983-2016)                    }
{=======================================================================}
{ Utols mdosts dtuma: 2017.05.30.                                  }
{            2016.07.14./2015.08.03./2004.07.22./2000.08.20./1999.08.08.}
{-----------------------------------------------------------------------}
{ RUNNING <egy nulla-, egy-, vagy tbbparamteres program>              }
{   Vgrehajtja a paramterknt megadott exe, vagy DOS batch programot  }
{=======================================================================}

{=======================================================================}
{  Fordtsi direktvk                                                 }
{-----------------------------------------------------------------------}
{>>>>    GLOBLIS DIREKTIVK    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<}
{-----------------------------------------------------------------------}
{ $D-}   {+: informcis tblt kszt a debugger rszre           !!!! }
{ $L-}   {+: loklis vltozk debugolst tmogatja (ha D+)         !!!! }
{ $Y-}   {+: protected mdban a kdba browse inf.-t tesz (ha D+,L+) !!!! }
{ $E-}   {+: beszerkeszti a koproc. emull rutinokat (ha N+)            }
{ $N-}   {+: koprocesszort hasznl, illetve E+ esetn emull             }
{   M 16384,1048576}   {Delphi alaprtelmezett stack min,max)            }
{   M 1024,2147483647} {Delphi szlsrtkek stack min,max)              }
{ $M 10000,20000000                                                      }
{-----------------------------------------------------------------------}
{>>>>     LOKLIS DIREKTIVK    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<}
{-----------------------------------------------------------------------}
{$A+}   {+: minden vltoz s tipusos konstans szhatrra kerl         }
{$B-}   {-: logikai feltteleket az els dntsi pontig rtkeli        }
{$C-}   {+: a fordt kdot generl az rvnyestsek tesztelsre      }
{$F-}   {+: Tvoli hvs engedlyezve                                   }
{$G-}   {+: Msik unit-ban lev globlis vltozra val hivatkozst eng.}
{$H-}   {+: A string tpust AnsiStringknt rtelmezi                    }
{$I+}   {+: az I/O hibaellenrzs bekapcsolva                           }
{$J+}   {-: letiltja a tpusos konstans rtkadst                     }
{$K-}   {-:                                                             }
{$M-}   {+: osztlyok futsiidej tpusinformcikkal egytt fordtdnak}
{$O+}   {+: a fordt optimalizl                                       }
{$P-}   {+: nyitott tmb s string tpus paramter szerepelhet         }
{$Q-}   {+: ellenrzi az egsz s felsorolt tp.aritm. tlcsordulst   }
{$R-}   {+: rtkhatr-ellenrz kdot generl                          }
//{$R *.xfm}
//{$R *.dfm}
{$S-}   {-:                                                             }
{$T-}   {+: ell.az @ (cm)opertor genrlta pointerrtk tpust        }
{$U-}   {+: a lebegpontos Pentium hiba kikszblse                   }
{$V-}   {+: a string tip.akt.s formlis paramter egyezst ellenrzi  }
{$W-}   {+: minden szubrutin hvshoz veremterletet foglal le          }
{$X+}   {+: fggvnyek eljrsknt is hvhatk (kiterjesztett szintaxis)}
{$Z4}   {1,2,4: a felsorolt tpust 1,2, vagy 4 Byte-on trolja          }
{=======================================================================}

PROGRAM RUNNING;

{$APPTYPE CONSOLE}
{$R *.res}

Uses
  {---------------------------------------------------------------------}
  //Messages,
  //Controls,
  //ShareMem,     // -> Megosztott file-kezels
  //Windows,      // -> MessageBox
  //Forms,        // -> Application.ExeName, MessageBox
  //Dialogs,      // -> ShowMessage, MessageDlg
  SysUtils,       // -> ExtractFilePath, StrCat, StrCopy, ...
  // Types, Classes, QGraphics, QControls, QForms, QDialogs, QStdCtrls,               //CLX - Linux
  Windows, Messages, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, //VCL - Windows
  Math,
  ShellApi;       // -> Kls program futtatsa
  {---------------------------------------------------------------------}
  //  DOS:     [RVZTR TKRFRGP - rvztr tkrfrgp]
  //  Windows: [RVZTR TKRFRGP - rvztr tkrfrgp]
  {---------------------------------------------------------------------}

LABEL
  USING, ENDE;

VAR
  Param : AnsiString; { a paramter paramtereinek gyjtemnye }

BEGIN
// goto ENDE;

  if ParamCount = 0 then
    goto USING;

  { A paramterek beolvassa }
  If ParamStr(8) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)+' '+ParamStr(7)+' '+ParamStr(8)
  else
  If ParamStr(7) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)+' '+ParamStr(7)
  else
  If ParamStr(6) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)
  else
  If ParamStr(5) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)
  else
  If ParamStr(4) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)
  else
  If ParamStr(3) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)
  else
  If ParamStr(2) <> ''
  then
    Param := ParamStr(2)
  else
    Param := '';

  { A paramterknt megadott exe program futtatsa }
  // ShellExecute(Application.Handle,'Open', 'programnv', 'paramterek', 'kezdknyvtr', ablakjellemz),
  //     ahol az ablakjellemz lehet SW_SHOW, vagy SW_SHOWNORMAL,
  //          a programnv s a paramterek pedig (akr klnbz) tvonalakkal megadottak is lehetnek
  // ShellExecute(Handle,'open', 'c:\windows\notepad.exe','c:\VALAMI.txt', nil, SW_SHOWNORMAL) ;
  // ShellExecute(Application.Handle,'open',PChar(ParamStr(1)),PChar(Param),'',SW_SHOW);
  // Hasznlata pldul: RUNNING.exe RUNNING.exe RUNNING.exe notepad.exe aaa.txt 
  ShellExecute(Application.Handle,'Open',PChar(ParamStr(1)),PChar(Param),nil,SW_SHOW);

  goto ENDE;

USING:
  WriteLn('170529: Egy legfeljebb 7 parameteres, vagy parameternelkuli exe, vagy batch program futtatasat vegzi.');
  WriteLn('Hasznalata: RUNNING <utasitas>');
  WriteLn('      vagy: RUNNING <utasitas> <parameter> ');
  WriteLn('      vagy: RUNNING <utasitas> <parameter> ... <parameter>');
  WriteLn('Nyomd le az Enter billentyut...');
  ReadLn;

ENDE:
END.
