-- 5.3.) RendszerJogosultsgok adsa az Alfa felhasznlnak, s j belpsi ksrlet
-- http://docs.oracle.com/cd/E11882_01/server.112/e41084/statements_9013.htm#SQLRF01603

ALTER SESSION SET NLS_LANGUAGE = ENGLISH;

CONNECT sys/OraclE-123 AS SYSDBA;

GRANT CREATE SESSION,
      CREATE TABLESPACE, CREATE USER,
      CREATE ANY DIRECTORY, CREATE ANY TABLE, CREATE ANY VIEW,
      ALTER TABLESPACE,  ALTER USER, ALTER ANY TABLE,
      DROP TABLESPACE,   DROP USER,
      DROP ANY DIRECTORY,   DROP ANY TABLE,   DROP ANY VIEW
  TO Alfa
  WITH ADMIN OPTION;

GRANT CREATE ANY CONTEXT, CREATE CLUSTER, CREATE DIMENSION,
      CREATE INDEXTYPE, CREATE JOB, CREATE MATERIALIZED VIEW,
      CREATE OPERATOR, CREATE PROCEDURE, CREATE SEQUENCE,
      CREATE SESSION, CREATE SYNONYM, CREATE TABLE, CREATE TRIGGER,
      CREATE TYPE, CREATE VIEW
  TO Alfa
  WITH ADMIN OPTION;

GRANT CREATE ANY LIBRARY, EXECUTE ANY TYPE, EXECUTE ANY PROCEDURE,
      DROP ANY LIBRARY, DROP ANY TYPE, DROP ANY PROCEDURE
  TO Alfa
  WITH ADMIN OPTION;

GRANT CREATE JOB, CREATE ANY JOB, CREATE EXTERNAL JOB, 
      CREATE EXECUTE ANY PROGRAM, 
      CREATE EXECUTE ANY CLASS, 
      CREATE MANAGE SCHEDULER
  TO Alfa
  WITH ADMIN OPTION;


