library RUNNER;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Windows, Messages, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, //VCL - Windows
  Math,
  ShellApi;       // -> Kls program futtatsa  

{$R *.res}

LABEL
  USING, ENDE;

VAR
  Param : AnsiString; { a paramter paramtereinek gyjtemnye }

BEGIN
// goto ENDE;

  if ParamCount = 0 then
    goto USING;

  { A paramterek beolvassa }
  If ParamStr(8) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)+' '+ParamStr(7)+' '+ParamStr(8)
  else
  If ParamStr(7) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)+' '+ParamStr(7)
  else
  If ParamStr(6) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)+' '+
             ParamStr(6)
  else
  If ParamStr(5) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)+' '+ParamStr(5)
  else
  If ParamStr(4) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)+' '+ParamStr(4)
  else
  If ParamStr(3) <> ''
  then
    Param := ParamStr(2)+' '+ParamStr(3)
  else
  If ParamStr(2) <> ''
  then
    Param := ParamStr(2)
  else
    Param := '';

  { A paramterknt megadott exe program futtatsa }
  // ShellExecute(Application.Handle,'Open', 'programnv', 'paramterek', 'kezdknyvtr', ablakjellemz),
  //     ahol az ablakjellemz lehet SW_SHOW, vagy SW_SHOWNORMAL,
  //          a programnv s a paramterek pedig (akr klnbz) tvonalakkal megadottak is lehetnek
  // ShellExecute(Handle,'open', 'c:\windows\notepad.exe','c:\VALAMI.txt', nil, SW_SHOWNORMAL) ;
  // ShellExecute(Application.Handle,'open',PChar(ParamStr(1)),PChar(Param),'',SW_SHOW);
  // Hasznlata pldul: RUNNING.exe RUNNING.exe RUNNING.exe notepad.exe aaa.txt 
  ShellExecute(Application.Handle,'Open',PChar(ParamStr(1)),PChar(Param),nil,SW_SHOW);

  goto ENDE;

USING:
  WriteLn('170529: Egy legfeljebb 7 parameteres, vagy parameternelkuli exe, vagy batch program futtatasat vegzi.');
  WriteLn('Hasznalata: RUNNER <utasitas>');
  WriteLn('      vagy: RUNNER <utasitas> <parameter> ');
  WriteLn('      vagy: RUNNER <utasitas> <parameter> ... <parameter>');
  WriteLn('Nyomd le az Enter billentyut...');
  ReadLn;

ENDE:
END.

